#include "mibload.h"
#include "../common/drawer.h"
#include "../common/ui.h"
#include "gvui.h"
#ifdef MGGL
  #include <gl/gl.h>
  #include <X11/Xirisw/GlxMDraw.h>
#endif

extern Display *dpy;
extern UIState  uistate;

/* private methods and variables */
/*****************************************************************************/

static void ui_delete_camera(Widget, XtPointer, XmAnyCallbackStruct *);

/*****************************************************************************/

Widget ui_create_camera(Widget parent, Widget *camret, DView *dv)
{
  Arg	 args[20];
  int	 n, sx, sy;
  char  *title;
  Atom   AProtocol;
  Widget shell, camform, camdraw;

#ifdef MGGL
  static GLXconfig db_rgb_desc[] = {
   { GLX_NORMAL, GLX_RGB, TRUE},
   { GLX_NORMAL, GLX_DOUBLE, TRUE},
   { GLX_NORMAL, GLX_ZSIZE, GLX_NOCONFIG },
   { 0,0,0 }
  };
#endif

/*****************************************************************************/

  WnGet(dv->win, WN_XSIZE, &sx);
  WnGet(dv->win, WN_YSIZE, &sy);
  WnGet(dv->win, WN_NAME, &title);

  n = 0;
  XtSetArg(args[n], XmNdeleteResponse, XmDO_NOTHING);n++;
  XtSetArg(args[n], XmNtitle, title); n++;
  XtSetArg(args[n], XmNwidth, sx); n++;
  XtSetArg(args[n], XmNheight, sy); n++;

  shell = XtAppCreateShell(title, "gv", topLevelShellWidgetClass,
				dpy, args, n);

/*****************************************************************************/

#ifdef MGX11
  n = 0;
  XtSetArg(args[n], XmNtitle, title); n++;
  XtSetArg(args[n], XmNwidth, sx); n++;
  XtSetArg(args[n], XmNheight, sy); n++;
  XtSetArg(args[n], XmNrubberPositioning, False); n++;
  XtSetArg(args[n], XmNbackground, BlackPixel(dpy, DefaultScreen(dpy))); n++;
  XtSetArg(args[n], XmNforeground, BlackPixel(dpy, DefaultScreen(dpy))); n++;


  camform = XmCreateForm(shell, title, args, n);
  XtManageChild(camform);
#endif

/*****************************************************************************/

  n = 0;
  XtSetArg(args[n], XmNwidth, sx); n++;
  XtSetArg(args[n], XmNheight, sy); n++;
#ifdef MGX11
  XtSetArg(args[n], XmNbackground, BlackPixel(dpy, DefaultScreen(dpy))); n++;
  XtSetArg(args[n], XmNleftAttachment, XmATTACH_FORM); n++;
  XtSetArg(args[n], XmNleftOffset, 0);n++;
  XtSetArg(args[n], XmNtopAttachment, XmATTACH_FORM); n++;
  XtSetArg(args[n], XmNtopOffset, 0);n++;
  XtSetArg(args[n], XmNrightAttachment, XmATTACH_FORM); n++;
  XtSetArg(args[n], XmNrightOffset, 0);n++;
  XtSetArg(args[n], XmNbottomAttachment, XmATTACH_FORM); n++;
  XtSetArg(args[n], XmNbottomOffset, 0);n++;
  XtSetArg(args[n], XmNhighlightThickness, 0); n++;
#endif

#ifdef MGX11
  camdraw = XtCreateManagedWidget("camdraw", xmDrawingAreaWidgetClass, camform,
		args, n);
#endif

#ifdef MGGL
  XtSetArg (args[n], GlxNglxConfig, db_rgb_desc); n++;

  camdraw = GlxCreateMDraw(shell, "camdraw", args, n);
#endif
  
/*****************************************************************************/

  *camret = camdraw;

  AProtocol = XmInternAtom(dpy, "WM_DELETE_WINDOW", False);
  XmAddWMProtocolCallback(shell, AProtocol, (XtCallbackProc) ui_delete_camera,
			(caddr_t)dv);

  return shell;
}

/*****************************************************************************/

static void ui_delete_camera(Widget w, XtPointer data,
			XmAnyCallbackStruct *cbs)
{
  extern int real_id(int);
  DView *dv = (DView *)data;

  gv_delete(dv->id);
  uistate.targetcam = INDEXOF(FOCUSID);
  ui_target_cameraspanel(real_id(FOCUSID));
}

/*****************************************************************************/
